#!/usr/bin/perl


# Contemplate Assembler (assembler.cgi) version 1.0.2
# Copyright 1999-2003 Type A Multimedia Network (http://www.typea.net)
# This file may be used, modified, or redistributed under the terms
# of the open-source agreement contained in docs/license.txt


# use the CGI.pm module to access CGI functionality

	use CGI;
	$cgi = new CGI;


# if the script is being used by the flattener or formulator, we'll give a different kind of output

	$get_info = $cgi->param('get_info');
	$skip_rendering = $cgi->param('skip_rendering');
	$formulator_fill = $cgi->param('formulator_fill');
	
	
# look out for a Flash flag and redirect to the Flash template if present

	$flash = $cgi->param('flash');
	if ($flash == 1) {
		print $cgi->redirect("../templates/templates.html?".$ENV{'QUERY_STRING'});
		exit;
	}
	

# initialize variables that we might use before setting

	$error_log = "";
	$show_errors = "";
	$output = "";
	$output_two = "";
	$output_info = "";
	$pre_render_files = 0;
	$read_page_definitions_from = "";
	$page_definitions = "";
	@template_pieces = ();
	$offset = 0;
	@embed_variable_keys = ();
	@embed_variable_values = ();
	@embeds = ();
	@tag_names = ();
	$tag_names_flattened = "";
	$file_fields = "";
	$stored_selections = "";
	$latest_mod_date = 0;	
	$latest_mod_date_formatted = "";	
	$template = "";
	$page_definition = "";
	$settings_used = "";
	$header = "";
	

# define some useful subroutines

	sub get_file {
		my $file = $_[0]; my $method = $_[1]; my $check_last_modified = $_[2]; my $text = ""; # method can be "http", "filesystem", or "auto" (auto looks at $pre_render_files list)
		if (($file =~ /\/(\.\w.*)/)) { # don't read files whose names start with "."
			$text = show_error("Not authorized to read the hidden file named \"$1\"");
		} else {
			
			# first, figure out if we're going to read over HTTP or through the filesystem...
			if (($method eq "")||($method eq "auto")) {
				if (@pre_render_files) {
					for ($n=0; $n < @pre_render_files; $n++) {
						if ($file =~ /@pre_render_files[$n]/) { $method = "http"; }
					}
				}
			}
			
			if ($method eq "http") {
				eval 'use LWP::Simple'; 
				if ($@) {
					$output .= show_error("Can\'t access Perl module LWP::Simple for pre-rendering files<br>Reading files directly instead<br>Hint: Set pre-render files to 0 in preferences.ini to skip this routine");
					$method = "filesystem";
				}
			}
			
			# ...then get the file
			if ($method eq "http") {
			
				# 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "http");

				# 2) read the file
				$myfile = get($file_URL);
				$file_exists = 1; # to do: how can we test for this?
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
					$text = $myfile;
				}
				
				#$output .= "<p>reading $file over http<p>";  # debug
				
			} else {
			
				# 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "filesystem");
				
				# 2) open a connection to the file
				open (myfile, $file_URL) or
				$text = show_error("Can't open the file named \"$file\"<br>$! $check_URL");
				if ($text =~ /Can't open/) {
					$file_missing = 1;
				} else {
				
					# 3) read the file
					while (<myfile>) { $text .= "$_"; }
					$file_missing = 0;
					
					# 4) for local files, catch the file's modification date (for $read_page_definitions_from and $template, plus content files when the template contains a env_last_modified tag)
					if ($check_last_modified) {
						($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($file_URL);
						if ($mtime > $latest_mod_date) {
							$latest_mod_date = $mtime;
							($second, $minute, $hour, $day, $month, $year, $weekday, $yearday, $dst_flag) = localtime($latest_mod_date);
							$year += 1900;
							$month = sprintf("%02d",$month+1);
							$day = sprintf("%02d",$day);
							if ($hour < 12) {
								$ampm = "am";
							} else {
								$ampm = "pm";
								if ($hour > 12) {
									$hour = $hour - 12;
								}
							}
							#$hour = sprintf("%02d",$hour);
							$minute = sprintf("%02d",$minute);
							$latest_mod_date_formatted = "$year-$month-$day - $hour:$minute $ampm";
						}
					}

					# 5) close the file connection
					close (myfile);
					
				}
				
				#$output .= "<p>reading $script_location_copy + $file_copy through filesystem<p>";

			}
			
			# finally, conform all line breaks to avoid cross-platform issues
			# we'd rather conform to Unix line breaks (\n), but that doesn't work in ASP, which doesn't support the s flag in regular expressions
			$text =~ s/\r\n/\r/g; # change DOS to Mac
			$text =~ s/\n/\r/g; # change Unix to Mac
	
		}
		return $text;
	}
	
	sub get_field {
		my $source_text = $_[0]; my $field_name = $_[1]; my $file_type = $_[2];
		if ($file_type =~ /xml/i) {
			
			$source_text = make_XML_paths($source_text);
			$tag_type = "content";
			if ($source_text =~ /<$tag_type[^>]+name=["']?$field_name["']?[^>]*>(.*?)<\/$tag_type>/is) {
				$field_text = $1;
			} else {
				$field_text = show_error("Can't find the $tag_type tag named \"$field_name\" in $content_file $check_URL");
			}

		} else {		

			unless ($field_name =~ /$field_marker/) {  # but what if formatting gets between the marker and the label?
				$field_name = $field_marker.$field_name;  # in that case, remove these lines and change $content_field to $field_marker.*$content_field below
			}
			if ($source_text =~ /$field_name(\W.*\/td>.*<td[^>]*>.*<\/td>)/is) {
				$field_text = $1;  # do a rough trim
				$field_text =~ s/<\/td>//i;  # remove up to the previous </td>
				$field_text =~ s/<td[^>]*>/split-here-hey/is;  # mark the opening <td>
				$field_text =~ s/$field_marker/split-here-hey/i;  # mark the next field marker
				@temp = split("split-here-hey", $field_text);  # trim at the markers
				$field_text = @temp[1];
				if ($field_text =~ /(.*)<\/td>/is) {  # remove from the trailing </td>
					$field_text = $1
				}
			} else {
				unless ($file_missing) {
					$field_text = show_error("Can't find the field named \"$field_name\" in $content_file $check_URL $check_field_label");
				}
			}

		}
		return $field_text;
	}
	
	sub get_form {
		my $source_text = $_[0]; my $form_element = $_[1];
		$value = "";
		
		# this function doesn't recognize values like this: <input name = foo> we could make it do so by adding /s* around all the equals signs, but it doesn't now
		
		# before looking for the value, let's find out if it has single or double quotes around it or not
		if ($source_text =~ /name=[\"\']?$form_element\W[^>]*value=[^\"\']/is) { $value_match = "([^ >]*)"; }
		elsif ($source_text =~ /name=[\"\']?$form_element\W[^>]*>.*?<option[^>]+value=[^\"\']/is) { $value_match = "([^ >]*)"; } # the previous line covers all other input types, but the select menu is different because the type and value are in different tags (we wouldn't need this if we could write a regex that spanned the <select> and <option> tags, but that wasn't too greedy with other input types)
		elsif ($source_text =~ /name=[\"\']?$form_element\W[^>]*value=\'/is) { $value_match = "'([^\']*?)'"; }
		elsif ($source_text =~ /name=[\"\']?$form_element\W[^>]*>.*?<option[^>]+value=\'/is) { $value_match = "'([^\']*?)'"; } # the previous line covers all other input types, but the select menu is different because the type and value are in different tags (we wouldn't need this if we could write a regex that spanned the <select> and <option> tags, but that wasn't too greedy with other input types)
		else { $value_match = "\"([^\"]*?)\""; } # we'll let the double quote be the default, so if something goes wrong we still might get the desired result
 
		# okay, now let's look for it
		if ($source_text =~ /<input[^>]+name=["']?$form_element\W[^>]*type=["']?text["']?[^>]+value=$value_match[^>]*>/is) { $value = $1; }
		elsif ($source_text =~ /<input[^>]+name=["']?$form_element\W[^>]*type=["']?radio["']?[^>]+value=$value_match[^>]+checked[^>]*>/is) { $value = $1; }
		elsif ($source_text =~ /<input[^>]+name=["']?$form_element\W[^>]*type=["']?checkbox["']?[^>]+value=$value_match[^>]+checked[^>]*>/is) {
			# return a list (not array) of all the checked boxes
			while ($source_text =~ /<input[^>]+name=["']?$form_element\W[^>]*type=["']?checkbox["']?[^>]+value=$value_match[^>]+checked[^>]*>/is) {
				$value .= "$1, ";
				$source_text =~ s/<input[^>]+name=["']?$form_element\W[^>]*type=["']?checkbox["']?[^>]+value=$value_match[^>]+checked[^>]*>//is;
			}
			$value = substr($value, 0, -2);
		}
		elsif ($source_text =~ /<select[^>]+name=["']?$form_element\W[^>]*>.*?<option[^>]+value=$value_match[^>]+selected[^>]*>.*?<\/select>/is) { $value = $1; }
		elsif ($source_text =~ /<textarea[^>]+name=["']?$form_element\W[^>]*>(.*?)<\/textarea>/is) { $value = $1; }
		else {
			if ($source_text =~ /name=[\"\']?$form_element\W/is) {
				# some HTML editors might remove the value attribute if it's empty, so maybe that's why we can't find the form element
				$value = "";
			} else {
				# otherwise, we give up
				$value = show_error("Can't find the form element named \"$form_element\" in $content_file $check_URL");
			}
		}
		return $value;
	}
	
	sub get_setting {
		my $source_text = $_[0]; my $setting = $_[1]; my $allow_override = $_[2]; my $allow_partial = $_[3]; my $value = "";
		
		# allow most preferences to be overridden through the argument string
		$setting_no_spaces = $setting;
		$setting_no_spaces =~ s/[ -]/_/g;
		$settings_used .= "$setting_no_spaces,";

		$override = $cgi->param($setting_no_spaces);
		if (($allow_override)&&($override ne "")) {
			$value = $override;
		} else {
			$source_text = "\r".$source_text;  # this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  # this lets us use more verbose labels in the ini file
				if ($source_text =~ /[^\w]$setting[^:\r]*: ([^\r]*)\r*/i) {
					$value = $1;
				}
			} else {  # this ensures an exact match in the pages file
				if ($source_text =~ /[^\w]$setting: ([^\r]*)\r*/i) {
					$value = $1;
				}
			}
		}
		if ($value eq "0") { $value = 0; } # this ensures that a 0 value will evaluate false in every language
		return $value;
	}
	
	sub get_page_name { # look for a page definition that exactly matches a given dynamic URL
		my $page_definition = $_[0]; my $source = $_[1];
        $source = "\r".$source; # this makes it easier to match a page definition on the first line of the file
		$page_name = ($source =~ /[^\w](\w+)\:\s+\Q$page_definition\E[\&\s\r]/) ? $1 : "" ;
		return $page_name;
	}
	
	sub get_page_names_containing { # look for page definitions that contain a given set of arguments
		my $args = $_[0]; my $source = $_[1];
		@pages = ();
		$source = "\r".$source; # this makes it easier to match a page definition on the first line of the file
		while ($source =~ /[^\w](\w+)\:\s+[^\r]+=\Q$args\E[^\r]*[\&\s\r]/) {
			push(@pages, $1);
			$source =~ s/([^\w])\w+\:\s+[^\r]+=\Q$args\E[^\r]*[\&\s\r]/$1/;
		}
		return @pages;
	}
	
	sub get_page_names { # return a list of all the page names in a page definitions file
		my $source = $_[0];
		@page_names = ();
		while ($source =~ /(\w+)\:\s+[\w]+/) {
			$this_page_name = $1;
			push(@page_names, $this_page_name);
			$source =~ s/$this_page_name\://;
		}
		return @page_names;
	}
	
	sub get_field_names { # return a list of all the content fields in a content file -- either HTML or XML depending on the second argument
		my $source = $_[0]; my $file_type = $_[1];
		@field_names = ();
		if ($file_type =~ /xml/i) {

			$source = make_XML_paths($source);
			$tag_type = "content";
			while ($source =~ /<$tag_type[^>]+name=["']?([\w\/]+)["']?[^>]*>/is) {
				$this_field_name = $1;
				push(@field_names, $this_field_name);
				$source =~ s/<$tag_type[^>]+name=["']?[\w\/]+["']?[^>]*>//is;
			}

		} else {

			while ($source =~ /$field_marker(\w+)/) {
				$this_field_name = $1;
				push(@field_names, $this_field_name);
				$source =~ s/$field_marker//;
			}

		}
		return @field_names;
	}
	
	sub get_form_names { # return a list of all the form elements in a content field
		my $source = $_[0];
		@form_names = ();
		while ($source =~ /<input[^>]+name=[\"\']?(\w+)\W[^>]*>/is) {
			$this_form_name = $1;
			push(@form_names, $this_form_name);
			$source =~ s/\Q$&\E//;
		}
		while ($source =~ /<select[^>]+name=[\"\']?(\w+)\W[^>]*>/is) {
			$this_form_name = $1;
			push(@form_names, $this_form_name);
			$source =~ s/\Q$&\E//;
		}
		while ($source =~ /<textarea[^>]+name=[\"\']?(\w+)\W[^>]*>/is) {
			$this_form_name = $1;
			push(@form_names, $this_form_name);
			$source =~ s/\Q$&\E//;
		}
		return @form_names;
	}
	
	sub make_XML_paths { # rewrite nested XML content as flat content with paths for tag names; assumes no more than one tag per line
		my $source = $_[0];
		@source = split("\r", $source);
		@path = ();
		for ($n=0; $n < @source; $n++) {
			$this_line = @source[$n];
			if ($this_line =~ /<group[^>]+name=["']?([\w]+)["']?[^>]*>/is) {
				$group_name = $1;
				push(@path, $group_name); # add the new group name to the path array
			} elsif ($this_line =~ /<\/group>/i) {
				$group_name = pop @path; # remove the latest group name from the path array
			} elsif ($this_line =~ /<content[^>]+name=["']?([\w]+)["']?[^>]*>/is) {
				$field_name = $1;
				if (@path > 0) {
					$current_path = join ("/", @path);
					$field_name = $current_path."/".$field_name;
					$this_line =~ s/(<content[^>]+name=["']?)[\w]+(["']?[^>]*>)/$1$field_name$2/is;
					@source[$n] = $this_line;
				}
			}
		}
		$source = join("\r", @source);
		return $source;
	}
	
	sub get_directory_listing { # return a list of all the items in the specified directory
		my $directory = $_[0];
		opendir(dir, absolute_path($directory, "filesystem")) or
		show_error("Can't read the contents of the directory '".$directory."'<p>");
		#@files = grep readdir(dir); # that gets all files
		#@files = grep {/\w+\..\w+/} readdir(dir); # that gets files only
		@files = grep {/^[^\.]/} readdir(dir); # that gets files that don't start with a dot
		closedir dir;
		return @files;
	}
	
	sub get_recursive_listing { # return a list of all the files in a given folder, including subfolders
		my $start_folder = $_[0]; my $recursive = $_[1]; my $filter = $_[2];
		$start_folder =~ s/[\/\\]$//; # remove a trailing slash
		@file_list = ();
		@folder_list = $start_folder;
		while (@folder_list) {
			$this_folder_path = @folder_list[0];
			@this_folder_items = get_directory_listing($this_folder_path);
			for ($n=0; $n<@this_folder_items; $n++) {
				$this_item_name = @this_folder_items[$n];
				$this_item_path = $this_folder_path."/".$this_item_name;
 				# if the item name contains a dot, we assume it's a file, if not, we assume it's a directory
 				if ($this_item_name !~ /\./) {
 					# we've found a folder; add it to the list of folders to scan
 					if ($recursive) {
						push(@folder_list, $this_item_path);
					}
				} elsif ((!$filter)||($this_item_name =~ /$filter/)) {
					# we've found a file; add it to the list of files to return
					$this_item_path =~ s/$start_folder\///; # make results relative to the start folder, not to the site
					push(@file_list, $this_item_path);
				}
			}
			shift @folder_list; # remove the folder we just scanned from the list
		}
		return @file_list;
	}
	
	sub show_error {
		my $message = $_[0];
		
		# prepare the shown message by removing quote marks
		$message_show = $message;
		$message_show =~ s/\"/&quot;/g;
		$message_show =~ s/'/&#039;/g;
		$message_show = "<table cellpadding=4 border=1><tr><td><b>Assembler error</b><br>$message_show</td></tr></table>";
		
		# prepare the hidden message by removing <br> tags
		$message_hide = $message_show;
		$message_hide =~ s/<br>/;/g;
		$message_hide = "<!-- Assembler error: $message_hide -->";
		
		# prepare the logged message by removing all but the first line
		$message_log = $message;
		if ($message_log =~ /<br>/) {
			$message_log = substr($message_log, 0, index($message_log, "<br>"));
		}
		$message_log = strip_tags($message_log); # also remove any HTML formatting from it
		
		# add the log message to the ongoing error log
		if ($error_log) { $error_log .= ","; } # and comma-delimit multiple errors on a page
		$error_log .= $message_log;
		
		# add the shown and hidden messages to the output
		if (($show_errors)&&($formulator_fill ne "-1")) {
			# only display one error at a time, since subsequent errors are usually a result of the first one
			if ($output !~ /Assembler error/) {
				return $message_show;
			}
		} else {
			return $message_hide;
		}
		
	}
	
	sub relative_path { # takes a reference to a file within our site and changes the initial delimiters if necessary
		my $path = $_[0]; my $subfolder = $_[1]; $this_read_file = ""; $error = ""; $validate_path = 0;
		$path =~ s/\:\/\///g;  # don't allow files from other servers
		if ($path =~ /\//) { $validate_path = 1; } # we can skip the validation if we just have a file directly the content folder
		if ((substr($path,0,3) ne "../")&&(substr($path,0,2) ne "./")) {
			# if the path doesn't include a site subfolder, add the subfolder we passed in
			if ($subfolder) { $subfolder .= "/"; }
			$path = "../".$subfolder.$path;
		}
		if ($validate_path) {
			# allow for nonstandard paths, if they're listed in the ini file
			if (@read_files_from) {
				for ($n=0; $n < $read_files_from_count; $n++) {
					if ($read_files_recursively) {
						# allow matches to subfolders
						if ($path =~ /^@read_files_from[$n].*/) { $this_read_file = 1; }
					} else {
						# require an exact match to this folder
						$path_no_filename = $path;
						$path_no_filename =~ s/(.*\/)[^\/]*/$1/;
						if ($path_no_filename eq @read_files_from[$n]) { $this_read_file = 1; }
					}
				}
			}
			#$output .= "<p>this_read_file: $this_read_file<p>";  # debug
			if (! $this_read_file) {
				if ($path =~ /(.*\/)[^\/]*/i) { $path_trimmed = $1; }
				$error = show_error("Not authorized to read from the path \"$path_trimmed\"<br>Hint: Add nonstandard paths to read files from list in preferences.ini");
			}
		}
		if ($error) {
			return $error;
		} else {
			return $path;
		}
	}
	
	sub absolute_path { # convert a reference to a file within our site to an absolute URL
		my $path = $_[0]; my $method = $_[1];
		if ($script_location) { # if this hasn't been set yet, just return the original value
		
			if ($method eq "filesystem") {
			
				$script_location_copy = $script_location;
				$path_copy = $path;
				while ($path_copy =~ /\.\.\//) {
					# this avoids results like contemplate/../templates/default.html
					$script_location_copy =~ s/[^\/]+\/$//; # remove the last directory name from the script location
					$path_copy =~ s/\.\.\///; # remove the first updelim from the filename
				}
				$path = $script_location_copy.$path_copy;
	
			} else {
			
				$thisserver = $ENV{"HTTP_HOST"};
				if ($request =~ /\/([^=]*\/)contemplate\//i) { $thispath = $1; }
				if ($request =~ /\/([^=]*\/)$URL_rewriting_flag\//i) { $thispath = $1; }
				
				# to do: how can we read the authentication info from this request so we can pass it on?
				$login = ""; 
				
				$path =~ s/\.\.\//http:\/\/$login$thisserver\/$thispath/i;
			
			}
		
		}
		return $path;
	}

	sub parse_int { # remove all but numeric characters from a string and convert to an integer
		my $str = $_[0];
		$str =~ s/\D//g;
		$int = int($str);
		return $int;
	}

	sub make_preview { # return a little bit before and a little bit after the selected text (used for search results)
		my $before_str = $_[0]; my $str = $_[1]; my $after_str = $_[2];
		$before_str = substr($before_str, -(int($search_results_preview_length / 2)));
		$after_str = substr($after_str, 0, int($search_results_preview_length / 2));
		$preview = "...$before_str<b>$str</b>$after_str...";
		return $preview;
	}

	sub strip_tags { # remove all HTML or other markup from text; this is a substitute for PHP's strip_tags() built-in function
		my $str = $_[0];
		$str =~ s/>[\r\s]</></g;
		$str =~ s/<[^>]*>//g;
		$str =~ s/^\s*//;
		$str =~ s/\s*$//;
		return $str;
	}


# set up some error messages that we can use later

	$check_URL = "<br>Hint: Check your page definition";
	$check_embed = "<br>Hint: Check your embed tag";
	$check_field_label = "<br>Hint: Check your content file and remove any formatting tags between the field marker and the field label";
	$change_tag_name = "<br>Hint: Choose a different name for this embed tag";
	

# set up some primary variables

	$URL_rewriting_flag = "assembled"; # we'd rather store this in the preferences file, but we need it in order to read the preferences file!

	# figure out the location of the contemplate directory as shown in the browser, and use that as the basis for open commands;
	# this allows us to run the script from a symlink to the real contemplate folder, and paths will be relative to the
	# apparent, rather than the actual, location of assembler.cgi
	# this will also prevent problems if Windows calculates relative paths from the server root
	$request = ($^O =~ /Win/) ? $ENV{'SCRIPT_NAME'} : ( (index($ENV{'REQUEST_URI'}, "?") != -1) ? substr($ENV{'REQUEST_URI'}, 0, index($ENV{'REQUEST_URI'}, "?")) : $ENV{'REQUEST_URI'} ) ;
	$script_location = ($^O =~ /Win/) ? $ENV{'PATH_TRANSLATED'} : $ENV{'SCRIPT_FILENAME'} ;
	$script_location =~ s/\\/\//g;
	if ($script_location =~ /(.*\/)$URL_rewriting_flag\//i) {
		$script_location = $1."contemplate/";
	} else {
		$script_location =~ s/(.*\/)[^\/]+/$1/;
	}


# read in a preferences (.ini) file if one exists, and show which preferences may be overridden from the URL string

	$preferences = get_file("preferences.ini", "filesystem", 0);
	if ($preferences) {
		$field_marker = get_setting($preferences, "field marker", 1, 1);
		#$URL_rewriting_flag = get_setting($preferences, "URL rewriting flag", 1, 1);
		$log_traffic = get_setting($preferences, "log site traffic", 1, 1);
		$show_errors = get_setting($preferences, "show errors", 1, 1);
		$pre_render_files = get_setting($preferences, "pre-render files", 1, 1);
		$read_files_from = get_setting($preferences, "read files from", 0, 1);
		$read_files_recursively = get_setting($preferences, "read files recursively", 0, 1);
		$read_page_definitions_from = get_setting($preferences, "read page definitions from", 1, 1);
		$prevent_page_caching = get_setting($preferences, "prevent page caching", 1, 1);
		$show_expanded_URLs = get_setting($preferences, "show expanded URLs", 1, 1);
		$external_link_target = get_setting($preferences, "external link target", 1, 1);
		$flash_link_color = get_setting($preferences, "flash link color", 1, 1);
		$search_results_preview_length = get_setting($preferences, "preview length", 1, 1);
		$line_ending = get_setting($preferences, "line ending", 1, 1);
		$show_source = get_setting($preferences, "show source", 1, 1);
		$show_source_to = get_setting($preferences, "show source to", 0, 1);
		$host_lookups = get_setting($preferences, "host lookups", 1, 1);
	} else {
		$field_marker = "";
		#$URL_rewriting_flag = "";
		$log_traffic = "";
		$show_errors = "";
		$pre_render_files = "";
		$read_files_from = "";
		$read_files_recursively = "";
		$read_page_definitions_from = "";
		$prevent_page_caching = "";
		$show_expanded_URLs = "";
		$external_link_target = "";
		$flash_link_color = "";
		$search_results_preview_length = "";
		$line_ending = "";
		$show_source = "";
		$show_source_to = "";
		$host_lookups = "";
	}
	
	
# do a bit of processing on the settings, and set some defaults in case preferences.ini or individual settings are absent

	if ($field_marker eq "") { $field_marker = "\#\#"; }
	
	#if ($URL_rewriting_flag eq "") { $URL_rewriting_flag = "assembled"; }

	if ($show_errors eq "") { $show_errors = "1"; }
	$show_errors = int($show_errors);

	if (($pre_render_files)&&($pre_render_files ne "1")&&($pre_render_files ne "0")) {
		$pre_render_files =~ s/, /,/g;
		@pre_render_files = split(",", $pre_render_files);
	}
	
	if ($read_files_from !~ /\.\.\/contemplate\//) { $read_files_from .= ", ../contemplate/"; }
	if ($read_files_from !~ /\.\.\/content\//) { $read_files_from .= ", ../content/"; }
	if ($read_files_from !~ /\.\.\/templates\//) { $read_files_from .= ", ../templates/"; }
	if ($read_files_from =~ /^, (.*)/) { $read_files_from = $1; }
	if ($read_files_from) {
		$read_files_from =~ s/, /,/g;
		@read_files_from = split(",", $read_files_from);
	} else {
		@read_files_from = ();
	}
	$read_files_from_count = @read_files_from;

	if ($read_files_recursively eq "") { $read_files_recursively = "1"; }
	$read_files_recursively = int($read_files_recursively);

	#if ($read_page_definitions_from eq "") { $read_page_definitions_from = "../contemplate/pages.txt"; }
	if ($read_page_definitions_from) {
		$read_page_definitions_from =~ s/, /,/g;
		@read_page_definitions_from = split(",", $read_page_definitions_from);
	} else {
		@read_page_definitions_from = ("pages.txt");
	}
	$read_page_definitions_from_count = @read_page_definitions_from;

	if ($show_expanded_URLs eq "") { $show_expanded_URLs = "0"; }
	$show_expanded_URLs = int($show_expanded_URLs);

	if ($flash_link_color =~ /\w{6}/) { $flash_link_color = "0000FF"; }

	if ($search_results_preview_length eq "") { $search_results_preview_length = 128; }

	if ($line_ending eq "") {
		$line_ending = "\n";
	} else {
		eval('$line_ending = '."\"$line_ending\";");
	}

	$show_source = int($show_source);

	if ($show_source_to) {
		$show_source_to =~ s/, /,/g;
		@show_source_to = split(",", $show_source_to);
		$show_source_to_count = @show_source_to;
	}

	if ($host_lookups eq "") { $host_lookups = "auto"; }
	

# write an HTTP header to prepare for text output

	if (!$get_info) {
		$header .= "Content-type: text/html\r";
	} else {
		$header .= "Content-type: text/plain\r";
	}
	if ($prevent_page_caching) {
  		# trick the browser into getting a new page every time
  		$header .= "Pragma: no-cache\r";
		$header .= "Cache-control: no-cache\r";
		$header .= "Expires: 07 May 1973 00:00:00 GMT\r";
	}


# parse the URL to figure out the arguments for this page

	$page = $cgi->param('page');
	$requested_page = $cgi->param('requested_page');
	if ($page) {
		# look in the page definitions file(s)...
		$page_definition = "";
		for ($i=0; $i<$read_page_definitions_from_count; $i++) {
			$this_read_page_definitions_from = @read_page_definitions_from[$i];
			$this_read_page_definitions_from = relative_path($this_read_page_definitions_from, "contemplate");
			if ($this_read_page_definitions_from =~ /not authorized/i) {
				$output .= $this_read_page_definitions_from;
			} else {
				$page_definitions = get_file($this_read_page_definitions_from, "filesystem", 1);
				$page_definition = get_setting($page_definitions, $page, 0, 0);
				if ($page_definition) { # CHECK FOR THE PRESENCE OF THE TEMPLATE VALUE ELSEWHERE
					# let any real-time args tag along for the ride
					$more_args = $ENV{'QUERY_STRING'};
					$more_args =~ s/&?page=[^&]+//;
					if ($more_args) { $page_definition .= "&".$more_args; }
					$page_definition =~ s/&+/&/g;
					if ($show_expanded_URLs) {
						# redirect to the page with the full URL visible
						$page_definition =~ s/&show_expanded_URLs=1//i;
						$page_definition .= "&requested_page=".$page;
						print $cgi->redirect("../contemplate/assembler.cgi?".$page_definition);
						exit;
					}
					$i = $read_page_definitions_from_count;
				}
			}
		}
		if ($page_definition eq "") {
			$read_page_definitions_from_plural = ($read_page_definitions_from_count > 1) ? "s" : "" ;
			$output .= show_error("Can't find a definition for \"$page\" in the file$read_page_definitions_from_plural ".join(", ", @read_page_definitions_from).".");
			# $header = "HTTP/1.0 404 Not Found\r".$header; // why doesn't this work?
		}
	} else {
		# ...or just use the current URL
		$page_definition = $ENV{'QUERY_STRING'};
		if ($requested_page) { $page = $requested_page; }
	}
	
	# remove our own arguments from the page definition if present
	$page_definition =~ s/&formulator_fill=1//i;
	$page_definition =~ s/&show_info=1//i;
	
	# don't proceed from here unless we have a page definition
	if ($page_definition) {
	
		# create arrays from the argument values, so we can more easily refer to their individual parts
		@args = split("&", $page_definition);
		$args_count = @args;
		for ($i=0; $i<$args_count; $i++) {
			@pair = split("=", @args[$i]);
			$key = @pair[0];
			$key = lc($key); # argument names are hereby declared case-insenstive
			# skip args that have the same name as a preference setting, so that we can control which settings can be overridden
			if (",$settings_used," !~ /,$key,/) {
				$value = (@pair > 1) ? @pair[1] : "" ;
				if ($value =~ /,/) {
					@{$key} = split(",", $value);
				} else {
					if ($key !~ /template/) {
						@{$key}[0] = $value;
					} else {
						$template = $value;
					}
				}
			}
		}
		
	
# grab the text of the template file
	
		if ($template) {
			$template_original = $template; # we'll save an unmodified version of this so we can access it in conditional and passthru tags
			$template = relative_path($template, "templates");
			if ($template !~ /not authorized/i) {
				$template_text = get_file($template, "auto", 1);
				$output .= $template_text;
			} else {
				$output .= $template;
			}
			$template = $template_original;
		}
		
	
# make the core processing recursive (e.g. process embed tags in embedded content)

		$i = 1;
		while (($output =~ /<!--\#\s*embed.*-->/is)||($output =~ /<!--\#\s*if.*-->/is)) {
		

# process any conditional tags to hide pieces of the template
	
			# first, find and number all if/else/end if sets (the template author had to do this manually before version 4.1)
			@levels = ();
			$greatest = 0;
			while ($output =~ /<!--\#\s*end[ ]*if\D/is) {
				# which is next, an if, else, or end if?
				if ($output =~ /<!--\#\s*if\D(.*)/is) { $length_after_if = length($1); } else { $length_after_if = -1; }
				if ($output =~ /<!--\#\s*else\D(.*)/is) { $length_after_else = length($1); } else { $length_after_else = -1; }
				if ($output =~ /<!--\#\s*end[ ]*if\D(.*)/is) { $length_after_end_if = length($1); } else { $length_after_end_if = -1; }
				if (($length_after_if > $length_after_end_if)&&($length_after_if > $length_after_else)) {
					$greatest++;
					push(@levels, $greatest);
					$output =~ s/<!--\#\s*if(\D)/<!--\#if$greatest$1/i;
					#$output .= "<br>adding if $greatest";  # debug
				} elsif (($length_after_else > $length_after_if)&&($length_after_else > $length_after_end_if)) {
					$next = @levels[$levels-1];
					$output =~ s/<!--\#\s*else(\D)/<!--\#else$next$1/i;
					#$output .= "<br>adding else $next";  # debug
				} else {
					$next = pop(@levels);
					$output =~ s/<!--\#\s*end[ ]*if(\D)/<!--\#end if$next$1/i;
					#$output .= "<br>adding end if $next";  # debug
				}
			}
			
			# then evaluate and process each of them
			while ($output =~ /<!--\#\s*if(\d+)[ ]*\(([^\r<]*[^ ])\)[ ]*-->/is) {  # ignore extra spaces around "if" and expression
				$j = $1;
				$this_expression = $2;
				$native_expression = $this_expression;
				$native_expression =~ s/==/eq/g; $native_expression =~ s/!=/ne/g;
	
				# the variable symbol @ is optional in the template; add it here if it's missing
				if ($native_expression !~ /\x40[_\w]+\[/) { $native_expression =~ s/([_\w]+\[)/\x40$1/g; }
				
				# these variables don't exist internally as arrays; this fakes it so they're still available in conditional tags
				$native_expression =~ s/\x40page\[0\]/\$page/ig;
				$native_expression =~ s/\x40template\[0\]/\$template/ig;
				$native_expression =~ s/\x40page_definition\[0\]/\$page_definition/ig;
				
				$this_evaluates = eval($native_expression);
				if ($output =~ /<!--\#\s*if$j[ ]*\([^\r<]*[^ ]\)[ ]*-->(.*)<!--\#\s*end[ ]*if$j[ ]*-->/is) {
					# always show embed tags in the formulator
					$conditional_content = $1;
					if (($conditional_content =~ /<!--\#\s*embed/i)&&($formulator_fill)) { $this_evaluates = 1; }
				}
				if ($output =~ /<!--\#\s*else$j\D/i) {
					if ($this_evaluates) {
						$output =~ s/<!--\#\s*if$j[ ]*\(([^\r<]*[^ ])\)[ ]*-->//is; # remove the if tag...
						$output =~ s/<!--\#\s*else$j\D.*end[ ]*if$j[ ]*-->//is; # ...and from the else tag to the end if tag
					} else {
						$output =~ s/<!--\#\s*if$j\D.*else$j[ ]*-->//is; # remove from the if tag to the else tag...
						$output =~ s/<!--\#\s*end[ ]*if$j[ ]*-->//is; # ...and the end if tag
					}
				} else {
					if ($this_evaluates) {
						$output =~ s/<!--\#\s*if$j[ ]*\(([^\r<]*[^ ])\)[ ]*-->//is; # remove the if tag
						$output =~ s/<!--\#\s*end[ ]*if$j[ ]*-->//is; # remove the end if tag
					} else {
						$output =~ s/<!--\#\s*if$j\D.*end[ ]*if$j[ ]*-->//is; # remove from the if to the end if tag
					}
				}
			}
			
		
# find all the embed tags in the template and replace with temporary placeholders
		
			# slower: while ($output =~ /(.*?)<!--\#\s*embed\s*([^\r]*?[^ ])\s*-->(.*)/is) {  # remove extra spaces before embed type, around "embed", and after attributes
			while ($output =~ /(<!--\#\s*embed\s*)([^\r]*?[^ ])(\s*-->)/is) {  # remove extra spaces before embed type, around "embed", and after attributes
		
				#slower: $before_embed = $1; $this_embed = $2; $after_embed = $3;
				$this_embed_complete = $1.$2.$3;
				$this_embed = $2;
				$this_embed = lc($this_embed); # embed tags are hereby declared case-insenstive
				$this_embed_copy = $this_embed;
				$this_type = "";
				$this_embed_variable = "";
				$this_embed_strip = "";
				@this_embed_replace = ();
				$this_embed_fill_defer = "";
				$this_embed_special = "";
				
				if ($get_info) {
					# we could get these by capturing the text before and after the embed tag in the regexp above, but that's a lot slower, especially in ASP
					@before_after_embed = split($this_embed_complete, $output);
					$before_embed = @before_after_embed[0];
					$after_embed = @before_after_embed[1];
					if ($i == 1) {
						@template_pieces[$i] = $before_embed; 
					} else {
						$offset += length(@template_pieces[($i-1)]) + length($last_content);
						@template_pieces[$i] = substr($before_embed, $offset);
					}
					@template_pieces[($i+1)] = $after_embed;
				}
				
				if ($this_embed =~ /\s+variable/) {  # look for a variable attribute, which tells us to save the embed content as a variable rather than add it to the output
					$this_embed_variable = 1;
					$this_embed =~ s/\s+variable//;
				}
				
				if ($this_embed =~ /\s+strip/) {  # look for a strip attribute, which tells us to remove all markup from the embed content
					$this_embed_strip = 1;
					$this_embed =~ s/\s+strip//;
				}
				
				if ($this_embed =~ /\s+replace/) {  # look for a replace attribute, which tells us to do some search-and-replaces on the embed content
					@this_replace_array = ();
					while ($this_embed =~ /\s+replace\s+\/([^\/]*)\/([^\/]*)\//) {
						$search = $1; $replace = $2;
						push(@this_replace_array, $search);
						push(@this_replace_array, $replace);
						$this_embed =~ s/\s+replace\s+\/[^\/]*\/[^\/]*\///;
					}
					@this_embed_replace = @this_replace_array;
					# $output .= "this_replace_array: ".@embeds_replace[$i - 1]; # debug
				}
				
				if ($this_embed =~ /\s+fill_defer/) {  # look for a fill_defer attribute, which tells us put the formulator fill fields at the end of the file
					$this_embed_fill_defer = 1;
					$this_embed =~ s/\s+fill_defer//;
				}
				
				$output =~ s/<!--\#\s*embed\s*\Q$this_embed_copy\E\s*-->/-embed-$i-/ig; # this is global so that if the same embed tag appears more than once, we only have to parse it once
				#$output .= "<p>Found embed tag: $this_embed\r\r";  # debug
				

# process each embed tag and replace the placeholders with real content
		
			# show a warning if we have one of our special variable names; you can't name an embed tag with one of these names
		
				if (($this_embed eq "page")||($this_embed eq "template")||($this_embed eq "page_definition")) {
					$content = show_error("The tag name \"$this_embed\" is a reserved word<br>Hint: Choose a different name for this embed tag");
					$this_type = "ignore";
				}
				
		
			# get the args if we've hardcoded them into the tag
		
				if ($this_embed =~ /args[ ]*=[ ]*([^ ]*)/is) {
					$this_args = $1;
					while ($this_args =~ /(\w+)\[(\d+)\]/) {
						# process passthru/hard-coded combos
						$variable_name = $1;
						$variable_index = $2;
						$key = $variable_name."[".$variable_index."]";
						$value = @{$variable_name}[$variable_index];
						$this_args =~ s/\Q$key\E/$value/g;
						$this_args =~ s/\+//g;
					}
					$this_embed = "hardcoded"; # it doesn't really matter what we use for the name here
					@{$this_embed} = split(",", $this_args);
					$this_embed_special = 1;
				}
				
		
			# set the type to passthru if we have a square bracket (and remove the optional @ to avoid errors)
		
				if ($this_embed =~ /(\w+)\[(\d+)\]/) {
					$this_embed = $1;
					$this_embed_passthru_index = $2;
					$this_type = "passthru";
					if (($this_embed eq "page")||($this_embed eq "template")||($this_embed eq "page_definition")) {
						# treat these as hard-coded values that shouldn't be set in the formulator
						$this_embed_special = 1;
					}
				}
				
		
			# set the type to the name if we have a navigation or environment tag
		
				if (($this_embed =~ /nav_/i)||($this_embed =~ /env_/i)) {
					$this_type = $this_embed;
					$this_embed_special = 1;
				}
				
		
			# if we don't have any of the previously listed special types, the type is the first argument
		
				if (! $this_type) {
					if (@{$this_embed}) { # to do: how can we check to make sure this variable is set? the exists() function throws an error
						# we don't need to check isarray here because a string and an array can't have the same name in Perl
						$this_type = @{$this_embed}[0];
					} else {
						$this_type = "skip";
					}
				}
				
		
			# show popup menus rather than content if we're running from the formulator
		
				if ($formulator_fill) {
				
					# the first time through, strip any form tags from the template so they don't interfere with the popup menus
					if ($i == 1) {
						$output =~ s/<form.*?>//gi;
						$output =~ s/<\/form.*?>//gi;
					}
					
					# if this isn't a special kind of embed tag, make some menus, or an input box for passthru tags
					if (! $this_embed_special) {
					
						# don't display an input form for any tag more than once, even though it might appear in the template more than once
						$tag_names_flattened = join(",", @tag_names);
						if (",$tag_names_flattened," !~ /,$this_embed,/) {
						
							if ($this_type !~ /passthr/) {
							
								$fill_forms = "
								
									<b>".uc($this_embed)."</b>
									<a href=JavaScript:parent.inspect_content('$this_embed')
									 onmouseover='document.images.inspector_$this_embed.src=\"graphics/inspector_1.gif\"'
									 onmouseout='document.images.inspector_$this_embed.src=\"graphics/inspector_0.gif\"'><img 
									src=graphics/inspector_0.gif
									 width=12 height=12 hspace=2 border=0
									 name=inspector_$this_embed alt='Inspect'></a><br>
								
									<form name=contemplate_$this_embed>
								
										<select name=embed_type onchange=parent.set_type('$this_embed')>
											<option value=-1>Embed type...</option>
											<option value=file>File</option>
											<option value=field>Field</option>
											<option value=form>Form</option>
											<option value=random>Random</option>
											<option value=none>None</option>
										</select><br>
								
										<img src=../graphics/spacer.gif width=1 height=2><br>
								
										<select name=embed_file onchange=parent.set_file('$this_embed')>
											<option value=0>(not needed)</option>
										</select><br>
								
										<img src=../graphics/spacer.gif width=1 height=2><br>
								
										<select name=embed_field onchange=parent.set_field('$this_embed')>
											<option value=0>(not needed)</option>
										</select><br>
								
										<img src=../graphics/spacer.gif width=1 height=2><br>
								
										<select name=embed_form>
											<option value=0>(not needed)</option>
										</select><p><br>
								
									</form>
									
								";
								
								if ($this_embed_fill_defer != 1) {
									# either display the popup menus right where the embedded content would be, and then stop parsing this tag...
									$content = $fill_forms;
									$this_embed_strip = "";
									@this_embed_replace = ();
									$this_embed_variable = "";
									$this_type = "ignore";
								} else {
									# ...or go ahead and parse this tag in place, and show the fill menus at the end of the page
									$output =~ s/<\/html>/$fill_forms<\/html>/is;
								}
			
								if (@{$this_embed}) { # to do: how can we check to make sure this variable is set? the exists() function throws an error
									$this_embed_flattened = join(",", @{$this_embed});
									$stored_selections .= "parent.show_stored('$this_embed', '$this_embed_flattened');\r\t\t\t\t\t\t\t";				
								}
								
							} else {
							
								# process passthru values a little differently -- just show a text field for them
								
								$fill_forms = "
								
									<b>".uc($this_embed)."</b><br>
								
									<form name=contemplate_$this_embed>
								
										<input type=text size=24 name=embed_value><br>
								
									</form>
								
								";
								
								# display the passthru field at the top of the page, because those tags are likely to appear inside HTML tags
								# this also emphasizes their global scope
								$output =~ s/(<body[^>]*>)/$1$fill_forms/is;
				
								if (@{$this_embed}) {
									$this_embed_flattened = join(",", @{$this_embed});
									$stored_selections .= "document.contemplate_$this_embed.embed_value.value = '$this_embed_flattened';\r\t\t\t\t\t\t\t";				
								}
			
							}
							
							push(@tag_names, $this_embed); # keep a list of all the embed tags we processed
						
						}
		
					}
				
				}
		
		
			# open the content file, which we can assume to be the second argument
			
				if (($this_type eq "file")||($this_type =~ /field/)||($this_type =~ /random/)||($this_type =~ /form/)) {
					$content_file = @{$this_embed}[1];
					$content_file = relative_path($content_file,"content");
					if ($content_file !~ /not authorized/i) {
						$content = get_file($content_file, "auto", 1);
					} else {
						$content = $content_file;
						$this_type = "error";
					}
					if ($file_missing) { $this_type = "error"; }
				}
		
		
			# get the desired piece of content...
			
			# ...for file
		
				if ($this_type =~ /file/) {
					# (no parsing necessary here)
				}
				
				
			# ...for random
		
				elsif ($this_type =~ /rand/) {
					$file_type = @{$this_embed}[1]; # determines whether we parse as HTML or XML
					@content_fields = get_field_names($content, $file_type);
					$count_fields = @content_fields;
					
					$content_field = @content_fields[int(rand($count_fields))];
					$content = get_field($content, $content_field, $file_type);       		
				}
				
		
			# ...for field
				
				elsif ($this_type =~ /field/) {
					$file_type = @{$this_embed}[1]; # determines whether we parse as HTML or XML
					$content_field = @{$this_embed}[2];
					$content = get_field($content, $content_field, $file_type);
			   }
			   
			   
			# ...for form
		
				elsif ($this_type =~ /form/) {
					$file_type = @{$this_embed}[1]; # determines whether we parse as HTML or XML
					$content_field = @{$this_embed}[2];
					$form_element = @{$this_embed}[3];
					$content = get_field($content, $content_field, $file_type);       		
					$content = get_form($content, $form_element);
				}
		
		
			# ...for search
				
				elsif ($this_type =~ /search/) {
					$search_string = $cgi->param('search_string');
					$search_files = $cgi->param('search_files');
					
					# skip if no search string entered
					if ($search_string ne "") {
					
						# if we haven't already loaded the page definitions file, do that now
						if (! $page_definitions) { $page_definitions = get_file(@read_page_definitions_from[0], "filesystem", 1); }
					
						# loop through each content file
						@content_files = get_recursive_listing("../content", 1, $search_files);
						$content_files_count = @content_files;
						for ($j=0; $j<$content_files_count; $j++) {
							$file_name = @content_files[$j];
							$file_text = get_file(relative_path($file_name, "content"), "filesystem", 0);
							#$output .= "Searching file $file_name<p>\r\r"; # debug
			
							# if the file contains the search string...
							if ($file_text =~ /(.*?)($search_string)(.*)/is) {
							
								# ...create a preview of the found text...
								$results_preview = make_preview($1, $2, $3);
								
								# ...and count how many times it appears in the field
								$frequency_file = 0;
							
								# then get the field names in the file, and loop through each field
								@content_fields = get_field_names($file_text, $file_name);
								$content_fields_count = @content_fields;
								for ($k=0; $k<$content_fields_count; $k++) {
									$field_name = @content_fields[$k];
									$field_text = get_field($file_text, $field_name, $file_name);
									$field_name = @content_fields[$k]; # we need to reinstate $field_name, which get_field() inadvertently changes
								
									# if the field contains the search string...
									$field_text = strip_tags($field_text); # exclude text contained in a tag
									if ($field_text =~ /(.*?)($search_string)(.*)/is) {
										
										# ...create a preview of the found text...
										$results_preview = make_preview($1, $2, $3);
										
										# ...and count how many times it appears in the field
										$frequency_field = 0;
										while ($field_text =~ /$search_string/is) {
											$frequency_field++;
											$frequency_file++;
											$field_text =~ s/$search_string//i;
										}
			
										# look up the relevant page names, then add the preview and frequency to our results array
										$found_args = "field,$file_name,$field_name";
										@pages = get_page_names_containing($found_args, $page_definitions);
										$pages_count = @pages;
										for ($n=0; $n<$pages_count; $n++) {
											%results = (%results, "@pages[$n] : $results_preview" => $frequency_field);
										}
										
									}
								
								}
								
								# look up the relevant page names, then add the preview and frequency to our results array
								$found_args = "file,$file_name";
								@pages = get_page_names_containing($found_args, $page_definitions);
								$pages_count = @pages;
								for ($n=0; $n<$pages_count; $n++) {
									%results = (%results, "@pages[$n] : $results_preview" => $frequency_file);
								}
								
							}
							
						}
						
						# rank the search results by frequency
						@results_keys = sort { (($results{$b} <=> $results{$a}) || ($a cmp $b)) } keys %results;
						@results_values = sort { int($b) <=> int($a) } values %results;
						
						#$content = "<table cellspacing=8 cellpadding=0 border=0>\r";  # these lines provide a different display option
						$content = "";
						$keys_count = @results_keys;
						for ($j=0; $j < $keys_count; $j++) {
							$this_page = substr(@results_keys[$j], 0, index(@results_keys[$j], " : "));
							$this_preview = substr(@results_keys[$j], index(@results_keys[$j], " : ") + 3);
							$this_frequency = @results_values[$j];
							#$content .= "<tr valign=top>\r<td class=body>$this_frequency</td>\r";
							#$content .= "<td class=body><a href=../contemplate/assembler.cgi?page=$this_page>contemplate/assembler.cgi?page=$this_page</a><br>\r<img src=../graphics/spacer.gif width=1 height=4 alt=''><br>\r$this_preview\r</td>\r</tr>";
							$content .= "<a href=../contemplate/assembler.cgi?page=$this_page>contemplate/assembler.cgi?page=$this_page</a><br>\r<img src=../graphics/spacer.gif width=1 height=4 alt=''><br>\r$this_preview ($this_frequency)<p>\r\r";
						}
						#$content .= "</table>\r";
						
						if ($content) {
							$content = "<b>Search results for \"$search_string\":</b><p>".$content;
						} else {
							$content = "<b>Can't find \"$search_string\"</b><p>";
						}
					} else {
						$content = "<b>Please enter a search string</b><p>";
					}
				}
		
		
			# ...for navigation
			
				elsif (($this_type =~ /nav_current/)||($this_type =~ /nav_total/)||($this_type =~ /nav_next/)||($this_type =~ /nav_prev/)||($this_type =~ /nav_first/)||($this_type =~ /nav_last/)) {
					
					# if we haven't already loaded the page definitions file, do that now
					if (! $page_definitions) { $page_definitions = get_file(@read_page_definitions_from[0], "filesystem", 1); }
					
					# if we came here from the expanded URL and not the page shortcut, get the page name now
					if (! $page) { $page = get_page_name($page_definition, $page_definitions); }
		
					$nav_page = $page;
					
					@nav_pages = ();
					$nav_page_position = 0;
					$count_pages = 0;
					
					# find the block of pages (separated by double line breaks) that this page belongs to
					# first, split the page definitions file up into blocks
					$pages_blocks = "\r\r$page_definitions\r\r";
					$pages_blocks =~ s/\r\r/\r\r\r/g;
					if ($pages_blocks =~ /.*\r\r(.*?\W$nav_page: .*?)\r\r.*/) {
						# then find the block that contains this page
						$nav_block = $1;
						$nav_block =~ s/\:[ ]*[^\r]*//g;
						$nav_block =~ s/^\r*(.*)\r*$/$1/g; # no trim function?
						@nav_pages = split ("\r", $nav_block);
						$count_pages = @nav_pages;
					}
					for ($j=0; $j<$count_pages; $j++) {
						# finally, parse through it to find this page's position in the block
						if (lc(@nav_pages[$j]) eq lc($nav_page)) {
							$nav_page_position = $j+1;
							last; # stop the loop
						}
					}
								
					if ($this_type =~ /nav_current/) {
						$content = int($nav_page_position); # return the position of the current page
					} elsif ($this_type =~ /nav_total/) {
						$content = $count_pages; # return the number of pages in this block
					} elsif ($this_type =~ /nav_first/) {
						$content = @nav_pages[0]; # return the name of the first page
					} elsif ($this_type =~ /nav_last/) {
						$content = @nav_pages[$count_pages - 1]; # return the name of the last page
					
					} else {
		
						# don't bother with the next part, if the current page doesn't exist
						if ($nav_page_position > 0) {
					
							if ($this_type =~ /nav_next/) {
								$result_page_position = $nav_page_position + 1;
								if ($result_page_position > $count_pages) { $result_page_position = 1; }
								$content = @nav_pages[$result_page_position - 1]; # return the name of the requested page
							} elsif ($this_type =~ /nav_previous/) {
								$result_page_position = $nav_page_position - 1;
								if ($result_page_position < 1) { $result_page_position = $count_pages; }
								$content = @nav_pages[$result_page_position - 1]; # return the name of the requested page
							}
							
						} else {
							$content = show_error("Can't find the page named \"$nav_page\" in @read_page_definitions_from[0]");
						}
						
					}
						
				}
		
		
			# ...for environment variable
			
				elsif ($this_type =~ /env_(.+)/) {
					$variable = $1;
					if ($variable =~ "last_mod") {
						$content = $latest_mod_date_formatted;
					} else {
						$content = $ENV{uc($1)};
					}
					
					# uncomment this to see all available variables
					#foreach $envbit (%ENV) { $output .= "$envbit<br>"; }  # debug
				}
		
		
			# ...for passthrough/passthru
			
				elsif ($this_type =~ /passthr/) {
					# these variables don't exist internally as arrays; this fakes it so they're still available in passthru tags
					if (($this_embed eq "page")||($this_embed eq "template")||($this_embed eq "page_definition")) {
						$content = ${$this_embed};
					} else {
						$content = @{$this_embed}[$this_embed_passthru_index];
					}
				}
		
		
			# ...or for nothing!
				
				elsif ($this_type =~ /skip/) {
					$content = "<!-- Embed tag \"$this_embed\" not parsed because of blank or too few arguments in URL -->";
				}
		
				elsif ($this_type =~ /ignore/) {
					# do nothing at all
				}
		
				elsif ($this_type !~ /error/) {
					$content = show_error("Can't understand the data type \"$this_type\"<br>Available types: file, field, random, form, search, nav_current, nav_total, nav_next, nav_previous, nav_first, nav_last, env_*, or passthru$check_embed");
				}
				
				
			# skip the rest of the parsing if this tag generated an error
			
				if ($content !~ /Assembler error/) {
				
				
				# remove all markup from the embed content if the strip attribute was included in the embed tag
				
					if ($this_embed_strip) {
						$content = strip_tags($content);
					}
				   
				   
				# do some search-and-replaces if the replace attribute was included in the embed tag
				
					if (@this_embed_replace) {
						$replace_count = @this_embed_replace / 2;
						for ($j=0; $j < $replace_count; $j++) {
							$search = @this_embed_replace[$j*2];
							$replace = @this_embed_replace[($j*2)+1];
							eval('$content =~ s/'.$search.'/'.$replace.'/g;');
						}
					}
				   
				   
				# do some final parsing of the content, when using a Flash template
			
					if ($template =~ /templates\.html/) {
					
						# remove extra spaces
						$content =~ s/[ ]*[\r\t\f][ ]*/ /g;
						while ($content =~ /  /) { $content =~ s/  / /g; }
						$content =~ s/> />/g;
						$content =~ s/ </</g;
						$output =~ s/content= /content=/g;
						
						# replace ampersands with a temporary placeholder
						$content =~ s/&/*amp*/g;
						
						# override link colors to a setting in preferences.ini
						$content =~ s/<(a href=[^>]*)>/<$1 target="_new"><font color="\#$flash_link_color">/gi;
						$content =~ s/<\/a>/<\/font><\/a>/gi;
						
						# change paragraph marks to line breaks
						$content =~ s/p>/p><br>/gi;
					
					}
				
				
				}
			
			
			# add the new content to the output...
			
				if (! $this_embed_variable) {
		
					# if the unflattener is calling this page, give it the content in separated, named chunks for easier parsing
					if ($get_info) {
						$output_info .= "<template_piece-$i>@template_pieces[$i]</template_piece-$i>\r\r";
						$output_info .= "<embed_type-$i>$this_type</embed_type-$i>\r";
						$output_info .= "<content_file-$i>$content_file</content_file-$i>\r";
						$output_info .= "<content-$i>$content</content-$i>\r\r";
						if ($output !~ /<!--\#.*-->/is) { $output_info .= "<template_piece-".($i+1).">".@template_pieces[($i+1)]."</template_piece-".($i+1).">\r\r"; }
					}
					
					$output =~ s/-embed-$i-/$content/g;
				
				}
				
		
			# ...or just save it as a variable and delete the embed placeholder
				
				else {
		
					push(@embed_variable_keys, $this_embed);
					push(@embed_variable_values, $content);
					
					$output =~ s/-embed-$i-//g;
		
				}
				
		
			# finally, start over with the next embed
			
				$last_content = $content;
				$content = "";
				$i++;
			
			}
	
		}


# add formulator data to the bottom of the document (we can't do this until we're done with recursive parsing)

	if ($formulator_fill) {
		
		$content_folder_only = 1; # we'll tell JavaScript whether we're using any nonstandard file locations
		@content_files = ();
		for ($j=0; $j<@read_files_from; $j++) {
			$this_directory = @read_files_from[$j];
			if (($this_directory ne "../contemplate/")&&($this_directory ne "../templates/")) {
				if ($this_directory ne "../content/") { $content_folder_only = 0; }
				@this_files = get_recursive_listing($this_directory, $read_files_recursively, "");
				for ($k=0; $k<@this_files; $k++) {
					$this_file = @this_files[$k];
					push(@content_files, $this_directory.$this_file);
				}
			}
		}
		$file_fields = "";
		$field_forms = "";
		
		# build an array of fields for each content file...
		for ($j=0; $j<@content_files; $j++) {
			$this_file_name = @content_files[$j];
			$this_file_nopunctuation = $this_file_name;
			$this_file_nopunctuation =~ s/\./_/g;
			$this_file_nopunctuation =~ s/\//_/g;
			$this_file_nopunctuation =~ s/ /_/g;
			$this_file_nopunctuation =~ s/^_*(.*)_*$/$1/g;
			$this_file_text = get_file($this_file_name, "filesystem", 0);
			@this_file_fields = get_field_names($this_file_text, $this_file_name);
			if (@this_file_fields) {
				$this_file_fields = join("', '", @this_file_fields);
				$file_fields .= "parent.".$this_file_nopunctuation."_fields = Array('$this_file_fields'); // file $j\r\t\t\t\t\t\t\t";
			}
			
			# ...and an array of forms for each field
			if (@this_file_fields) { @this_file_fields = split("', '", $this_file_fields); }
			for ($k=0; $k<@this_file_fields; $k++) {
				$this_field_name = @this_file_fields[$k];
				$this_field_nopunctuation = $this_field_name;
				$this_field_nopunctuation =~ s/\./_/g;
				$this_field_nopunctuation =~ s/\//_/g;
				$this_field_nopunctuation =~ s/ /_/g;
				$this_field_nopunctuation =~ s/^_*(.*)_*$/$1/g;
				$this_field_text = get_field($this_file_text, $this_field_name, $this_file_name);
				@this_field_forms = get_form_names($this_field_text);
				if (@this_field_forms) {
					$this_field_forms = join("', '", @this_field_forms);
					$field_forms .= "parent.".$this_file_nopunctuation."_".$this_field_nopunctuation."_forms = Array('$this_field_forms'); // form $j:$k\r\t\t\t\t\t\t\t";
				}
			}
		}
		
		$tag_names_javascript = join ("', '", @tag_names);
		$content_files_javascript = join ("', '", @content_files);

		$fill_data = "
		
			<script language=JavaScript>
		
				function load_menu(menu_name, menu_title, values) {
					clear_menu(menu_name, menu_title);
					menu_name.options[0] = new Option(menu_title, '0');
					if (values.length) {
						for (i=0; i < values.length; i++) {
							this_value = values[i];
							if (menu_title == 'File...') {
								if (parent.content_folder_only) {
									// remove the '../content/' if all the files are in that folder
									this_value_display = this_value.substring(11, this_value.length);
								} else {
									// just remove the '../' otherwise
									this_value_display = this_value.substring(3, this_value.length);
								}
							} else {
								this_value_display = this_value;
							}
							menu_name.options[i+1] = new Option(this_value_display, this_value);
						}
					} else {
						menu_name.options[1] = new Option('(none available)', '0');
					}
				}
				
				function clear_menu(menu_name, menu_title) {
					menu_name.options[0] = new Option(menu_title, '0');
					for (i=menu_name.options.length; i > 1; i--) {
						menu_name.options[i-1] = null;
					}
				}

				parent.tag_types = Array('file', 'field', 'form', 'random', 'none');

				parent.tag_names = Array('$tag_names_javascript');
				
				parent.content_files = Array('$content_files_javascript');
				
				parent.content_folder_only = $content_folder_only;

				$file_fields
				
				$field_forms
				
				$stored_selections
		
			</script>
			
		";
		
		$output =~ s/<\/html>/$fill_data<\/html>/is; # insert the JavaScript at the end of the file
		
	}


# merge argument values back together, since other scripts won't expect them to be arrays
	
		for ($i=0; $i<$args_count; $i++) {
			$pair = split("=", $args[$i]);
			$key = @pair[0];
			if (",$settings_used," !~ /,$key,/) {
				$value = (@pair > 1) ? @pair[1] : "" ;
				${$key} = $value;
			}
		}
		
	
# put content into any embed tag names marked with the variable attribute (we do this after merging argument variables in case they have the same names)
	
		$embed_variable_keys_count = @embed_variable_keys;
		for ($i=0; $i<$embed_variable_keys_count; $i++) {
			${@embed_variable_keys[$i]} = @embed_variable_values[$i];
		}


# set external link targets if requested in prefs file
	
		if ($external_link_target) {
			# add our default target to every anchor tag
			$output =~ s/<a href=([\'\"]?http:[^>]*)>/<a href=$1 target=$external_link_target>/g;
			# then remove it from every tag that already had one
			$output =~ s/<a href=([\'\"]?http:[^>]*target=[^>]*) target=[^>]*>/<a href=$1>/g;
		}
	
	
	} # end of the "if $page_definition" check


# return the parsed text as an HTML file

	$header =~ s/\r/\n/g; $header .= "\n"; # although we're using Mac line breaks during parsing, the header needs to be Unix
	print $header;
	#print "\n"; # divider between header and body
	
	if ($get_info) {
		# feed specially-formatted output to the flattener
		print $output_info;
	} else {
	
		# change to the preferred line ending set in preferences.ini
		$output =~ s/\r/$line_ending/g;
	
		print $output;
		
 		# if requested, display the output in a numbered, pre-rendered format so we can see where an error occurred
 		# but only allow this from IP addresses listed in the preferences file
 		$show_source_approved = 0;
		if (@show_source_to) {
			for ($i=0; $i < $show_source_to_count; $i++) {
				if ($ENV{'REMOTE_ADDR'} eq @show_source_to[$i]) { $show_source_approved = 1; }
			}
		}
		if (($show_source)&&($show_source_approved)) {
 			$output_numbered = $output;
			$output_numbered =~ s/</&lt;/g;
			$output_numbered =~ s/>/&gt;/g;
 			@output_numbered = split($line_ending, $output_numbered);
 			$output_numbered_count = @output_numbered;
 			for ($i=0; $i<$output_numbered_count; $i++) {
 				@output_numbered[$i] = "<tr valign=top><td><font face=geneva,verdana,sans-serif color=#999999>".($i+1)."</font></td><td>&nbsp;</td><td><font face=geneva,verdana,sans-serif>".@output_numbered[$i]."</font></td></tr>";
 			}
 			$output_numbered = join($line_ending, @output_numbered);
			print "<html>\r<body bgcolor=#FFFFFF>\r<p>\r<table>\r$output_numbered\r</table>\r</p>\r</body>\r</html>\r";
		}

	}


# log this hit in the traffic reports

	if (($log_traffic)&&(!$get_info)&&(!$formulator_fill)) {
	
		if (($request =~ "assembler.cgi")||($request =~ "$URL_rewriting_flag/")) {
			# if we recognize the request as a call to the assembler, display either the page name or the expanded URL
			if (!$page) { $page = $page_definition; }
		} else {
		 	# ... otherwise, we must have been redirected to here, so show the original request with the error code
		 	$page = substr($request,1); # the substr removes the initial slash
		 	$error_log = ($ENV{'REDIRECT_STATUS'}) ? $ENV{'REDIRECT_STATUS'} : "Unknown" ;
		}
		
		# catch the other environment variables now, or bring them in from the wrapper when we're using that (Perl only)
		$from_wrapper = $cgi->param('from_wrapper');
		if ($from_wrapper) {
			$IP_address = $cgi->param('IP_address');
			$host = $cgi->param('host');
			$user_agent = $cgi->param('user_agent');
			$referrer = $cgi->param('referrer');
			$page = substr($page, 0, index($page, "&from_wrapper"));
		} else {
			$IP_address = $ENV{'REMOTE_ADDR'};
			$host = ($ENV{'REMOTE_HOST'}) ? $ENV{'REMOTE_HOST'} : $IP_address ; # if we knew that all servers substituted the IP address for us when the host is missing, then we could remove the conditional here
			$user_agent = $ENV{'HTTP_USER_AGENT'};
			$referrer = $ENV{'HTTP_REFERER'};
		}

		# find out whether we need to do our own host lookup
		if ($host_lookups eq "auto") {
			$host_lookups = ($host eq $IP_address) ? "on" : "off" ;
		}
		if ($host_lookups eq "on") {
			eval 'use Net::hostent';
			if (!$@) {
				if (($host !~ /192\.168\.0\./)&&($host !~ /10\.0\.1\./)&&($host !~ /127\.0\.0\./)) {
					$host = pack("C4", split(".", $host));
					$host = (gethostbyaddr $host, 2); #->name;
				}
			}
		}

		# generate an SQL-standard timestamp
		$now = time;
		($second, $minute, $hour, $day, $month, $year, $weekday, $yearday, $dst_flag) = localtime($now);
		$year += 1900;
		$month = sprintf("%02d",$month+1);
		$day = sprintf("%02d",$day);
		$hour = sprintf("%02d",$hour);
		$minute = sprintf("%02d",$minute);
		$second = sprintf("%02d",$second);
		$SQL_timestamp = "$year-$month-$day $hour:$minute:$second";
		
		$traffic_file = $script_location."reporter/data/".$year."-".$month.".txt";
		$error_file = $script_location."reporter/data/".$year."-".$month."-errors.txt";
		
		if (!$error_log) {
			open (trafficfile, ">>$traffic_file") or
			$output_two .= "<!-- Can't open the traffic data file $traffic_file: $! -->\r";
			unless ($output_two =~ /data/) {
				print trafficfile "$SQL_timestamp\t$IP_address\t$host\t$page\t$user_agent\t$referrer\r";
				close trafficfile;
			}
		} else {
			open (errorfile, ">>$error_file") or
			$output_two .= "<!-- Can't open the error file $error_file: $! -->\r";
			unless ($output_two =~ /Can't open/) {
				print errorfile "$SQL_timestamp\t$IP_address\t$host\t$page\t$user_agent\t$referrer\t$error_log\r";
				close errorfile;
			}
		}
		
		print $output_two;
		
	}


# we're done!

	exit;
