#!/usr/bin/perl


# Contemplate Flattener (flattener.cgi) version 1.0.2
# Copyright 1999-2003 Type A Multimedia Network (http://www.typea.net)
# This file may be used, modified, or redistributed under the terms
# of the open-source agreement contained in docs/license.txt


# use the CGI.pm module to access CGI functionality

	use CGI;
	$cgi = new CGI;


# initialize variables that we might use before setting

	$flatten = 0;
	$unflatten = 0;
	$input_file = "";
	$output_file = "";
	$stop = 0;
	$failures = 0;
	$result = "";
	$output = "";
	$page_name = "";
	$pre_render_files = 1;
	$this_failure = 0;
	$changed = 0;
	$field_marker = "";
	$read_page_definitions_from = "";
	$unconvert_error = "";
	$changed_files = "";
	$check_URL = "";
	$settings_used = "";
	$template = "";
	$latest_mod_date = 0;


# define some useful subroutines

	sub convert_URLs {
		my $text = $_[0]; my $name = $_[1];
	
		# convert URLs like ../assembled/page.html
		$text =~ s/$URL_rewriting_flag\//flattened\//ig;
		
		# convert URLs like ../contemplate/assembler.cgi?page=page
		$text =~ s/contemplate\/assembler\.cgi\?page\=([^<>\s\'\"]+)([<>\s\'\"])/flattened\/$1\.html$2/ig;

		# convert URLs like ../contemplate/assembler.cgi?template=default&main=field,main,home
		if ($text =~ /contemplate\/assembler\.cgi\?(template\=[^<>\s\'\"]+)[<>\s\'\"]/i) {
			$dynamic_page = $1;
			$page_name = get_page_name($dynamic_page);
			if ($page_name ne "") {
				$text =~ s/contemplate\/assembler\.cgi\?(template\=[^<>\s\'\"]+)([<>\s\'\"])/flattened\/$page_name\.html$2/ig;
			} else {
				$result .= "<font color=red>Error: Can't find a page name for $dynamic_page in $name.</font><br>";
			}
		}
		
		return $text;
	}

	sub unconvert_URLs {
		my $text = $_[0]; my $format_sample = $_[1]; $unconvert_error = "";
		$flat_path = "../flattened/";
		$dynamic_path_short = "../$URL_rewriting_flag/";
		$dynamic_path_medium_cgi = "../contemplate/assembler.cgi?page=";
		$dynamic_path_medium_php = "../contemplate/assembler_wrapper.php?page=";
		if (($format_sample =~ /$dynamic_path_short/i)&&(($format_sample =~ /\Q$dynamic_path_medium_cgi\E/i)||($format_sample =~ /\Q$dynamic_path_medium_php\E/i))) {
			$unconvert_error = "Error: Assembled page may only contain short or medium format dynamic URLs, not both<br>";
		} else {
			if ($format_sample =~ /$dynamic_path_short/i) {
				# convert flattened URLs to ../assembled/page.html
				$text =~ s/$flat_path/$dynamic_path_short/ig;
			} elsif (($format_sample =~ /\Q$dynamic_path_medium_cgi\E/i)||($format_sample =~ /\Q$dynamic_path_medium_php\E/i)) {
				# convert flattened URLs to ../contemplate/assembler.cgi?page=page
				$text =~ s/$flat_path([^<>\s\'\"]+)\.html/$dynamic_path_medium_cgi$1/ig;
				$text =~ s/$flat_path([^<>\s\'\"]+)\.php/$dynamic_path_medium_php$1/ig;
			}
		}
		return $text;
	}

	sub get_file {
		my $file = $_[0]; my $method = $_[1]; my $check_last_modified = $_[2]; my $text = ""; # method can be "http", "filesystem", or "auto" (auto looks at $pre_render_files list)
		if (($file =~ /\/(\.\w.*)/)) { # don't read files whose names start with "."
			$text = show_error("Not authorized to read the hidden file named \"$1\"");
		} else {
			
			# first, figure out if we're going to read over HTTP or through the filesystem...
			if (($method eq "")||($method eq "auto")) {
				if (@pre_render_files) {
					for ($n=0; $n < @pre_render_files; $n++) {
						if ($file =~ /@pre_render_files[$n]/) { $method = "http"; }
					}
				}
			}
			
			if ($method eq "http") {
				eval 'use LWP::Simple'; 
				if ($@) {
					$output .= show_error("Can\'t access Perl module LWP::Simple for pre-rendering files<br>Reading files directly instead<br>Hint: Set pre-render files to 0 in preferences.ini to skip this routine");
					$method = "filesystem";
				}
			}
			
			# ...then get the file
			if ($method eq "http") {
			
				# 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "http");

				# 2) read the file
				$myfile = get($file_URL);
				$file_exists = 1; # to do: how can we test for this?
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
					$text = $myfile;
				}
				
				#$output .= "<p>reading $file over http<p>";  # debug
				
			} else {
			
				# 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "filesystem");
				
				# 2) open a connection to the file
				open (myfile, $file_URL) or
				$text = show_error("Can't open the file named \"$file\"<br>$! $check_URL");
				if ($text =~ /Can't open/) {
					$file_missing = 1;
				} else {
				
					# 3) read the file
					while (<myfile>) { $text .= "$_"; }
					$file_missing = 0;
					
					# 4) for local files, catch the file's modification date (for $read_page_definitions_from and $template, plus content files when the template contains a env_last_modified tag)
					if ($check_last_modified) {
						($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($file_URL);
						if ($mtime > $latest_mod_date) {
							$latest_mod_date = $mtime;
							($second, $minute, $hour, $day, $month, $year, $weekday, $yearday, $dst_flag) = localtime($latest_mod_date);
							$year += 1900;
							$month = sprintf("%02d",$month+1);
							$day = sprintf("%02d",$day);
							if ($hour < 12) {
								$ampm = "am";
							} else {
								$ampm = "pm";
								if ($hour > 12) {
									$hour = $hour - 12;
								}
							}
							#$hour = sprintf("%02d",$hour);
							$minute = sprintf("%02d",$minute);
							$latest_mod_date_formatted = "$year-$month-$day - $hour:$minute $ampm";
						}
					}

					# 5) close the file connection
					close (myfile);
					
				}
				
				#$output .= "<p>reading $script_location_copy + $file_copy through filesystem<p>";

			}
			
			# finally, conform all line breaks to avoid cross-platform issues
			# we'd rather conform to Unix line breaks (\n), but that doesn't work in ASP, which doesn't support the s flag in regular expressions
			$text =~ s/\r\n/\r/g; # change DOS to Mac
			$text =~ s/\n/\r/g; # change Unix to Mac
	
		}
		return $text;
	}
	
	sub get_setting {
		my $source_text = $_[0]; my $setting = $_[1]; my $allow_override = $_[2]; my $allow_partial = $_[3]; my $value = "";
		
		# allow most preferences to be overridden through the argument string
		$setting_no_spaces = $setting;
		$setting_no_spaces =~ s/[ -]/_/g;
		$settings_used .= "$setting_no_spaces,";

		$override = $cgi->param($setting_no_spaces);
		if (($allow_override)&&($override ne "")) {
			$value = $override;
		} else {
			$source_text = "\r".$source_text;  # this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  # this lets us use more verbose labels in the ini file
				if ($source_text =~ /[^\w]$setting[^:\r]*: ([^\r]*)\r*/i) {
					$value = $1;
				}
			} else {  # this ensures an exact match in the pages file
				if ($source_text =~ /[^\w]$setting: ([^\r]*)\r*/i) {
					$value = $1;
				}
			}
		}
		if ($value eq "0") { $value = 0; } # this ensures that a 0 value will evaluate false in every language
		return $value;
	}
	
	sub get_page_name { # look for a page definition that exactly matches a given dynamic URL
		my $page_definition = $_[0]; my $source = $_[1];
        $source = "\r".$source; # this makes it easier to match a page definition on the first line of the file
		$page_name = ($source =~ /[^\w](\w+)\:\s+\Q$page_definition\E[\&\s\r]/) ? $1 : "" ;
		return $page_name;
	}

	sub get_page_names { # return a list of all the page names in a page definitions file
		my $source = $_[0];
		@page_names = ();
		while ($source =~ /(\w+)\:\s+[\w]+/) {
			$this_page_name = $1;
			push(@page_names, $this_page_name);
			$source =~ s/$this_page_name\://;
		}
		return @page_names;
	}
	
	sub get_directory_listing { # return a list of all the items in the specified directory
		my $directory = $_[0];
		opendir(dir, absolute_path($directory, "filesystem")) or
		show_error("Can't read the contents of the directory '".$directory."'<p>");
		#@files = grep readdir(dir); # that gets all files
		#@files = grep {/\w+\..\w+/} readdir(dir); # that gets files only
		@files = grep {/^[^\.]/} readdir(dir); # that gets files that don't start with a dot
		closedir dir;
		return @files;
	}

	sub absolute_path { # convert a reference to a file within our site to an absolute URL
		my $path = $_[0]; my $method = $_[1];
		if ($script_location) { # if this hasn't been set yet, just return the original value
		
			if ($method eq "filesystem") {
			
				$script_location_copy = $script_location;
				$path_copy = $path;
				while ($path_copy =~ /\.\.\//) {
					# this avoids results like contemplate/../templates/default.html
					$script_location_copy =~ s/[^\/]+\/$//; # remove the last directory name from the script location
					$path_copy =~ s/\.\.\///; # remove the first updelim from the filename
				}
				$path = $script_location_copy.$path_copy;
	
			} else {
			
				$thisserver = $ENV{"HTTP_HOST"};
				if ($request =~ /\/([^=]*\/)contemplate\//i) { $thispath = $1; }
				if ($request =~ /\/([^=]*\/)$URL_rewriting_flag\//i) { $thispath = $1; }
				
				# to do: how can we read the authentication info from this request so we can pass it on?
				$login = ""; 
				
				$path =~ s/\.\.\//http:\/\/$login$thisserver\/$thispath/i;
			
			}
		
		}
		return $path;
	}

	sub show_error { # error display isn't as well developed here as in assembler, but we'll put this here so we can share more code
		my $message = $_[0];
		return "Error: ".$message;
	}
	
	
# set up some primary variables

	$URL_rewriting_flag = "assembled"; # we'd rather store this in the preferences file, but we need it in order to read the preferences file!

	# figure out the location of the contemplate directory as shown in the browser, and use that as the basis for open commands;
	# this allows us to run the script from a symlink to the real contemplate folder, and paths will be relative to the
	# apparent, rather than the actual, location of assembler.cgi
	# this will also prevent problems if Windows calculates relative paths from the server root
	$request = ($^O =~ /Win/) ? $ENV{'SCRIPT_NAME'} : ( (index($ENV{'REQUEST_URI'}, "?") != -1) ? substr($ENV{'REQUEST_URI'}, 0, index($ENV{'REQUEST_URI'}, "?")) : $ENV{'REQUEST_URI'} ) ;
	$script_location = ($^O =~ /Win/) ? $ENV{'PATH_TRANSLATED'} : $ENV{'SCRIPT_FILENAME'} ;
	$script_location =~ s/\\/\//g;
	if ($script_location =~ /(.*\/)$URL_rewriting_flag\//i) {
		$script_location = $1."contemplate/";
	} else {
		$script_location =~ s/(.*\/)[^\/]+/$1/;
	}
	
	$flatten = $cgi->param('flatten');
	$input_file = $cgi->param('input_file');
	$output_file = $cgi->param('output_file');
	$unflatten = $cgi->param('unflatten');
		
	$successes = 0;
	$failures = 0;
	$changes = 0;


# read in a preferences (.ini) file if one exists

	$preferences = get_file("preferences.ini", "filesystem", 0);
	if ($preferences) {
		$field_marker = get_setting($preferences, "field marker", 1, 1);
		#$URL_rewriting_flag = get_setting($preferences, "URL rewriting flag", 1, 1);
		$read_page_definitions_from = get_setting($preferences, "read page definitions from", 1, 1);
	} else {
		$field_marker = "";
		#$URL_rewriting_flag = "";
		$read_page_definitions_from = "";
	}
	
	
# do a bit of processing on the settings, and set some defaults in case preferences.ini or individual settings are absent

	if ($field_marker eq "") { $field_marker = "##"; }

	#if ($URL_rewriting_flag eq "") { $URL_rewriting_flag = "assembled"; }

	if ($read_page_definitions_from eq "") { $read_page_definitions_from = "pages.txt"; }


# write a generic header to prepare for text output

	$header = $cgi->header;
	print $header;
	

# set up the HTML page
	
	print "
	
		<html>
	
		<head>
		
			<title>Contemplate(tm) Web Content Manager</title>
			
			<link rel=stylesheet href=stylesheet.css type=text/css>
		
			<script language=JavaScript> login = 0; </script>
			<script language=JavaScript src=login/login.js></script>		
			<script language=JavaScript> if (!login) { location = '../index.html'; } </script>

		</head>
		
		<body bgcolor=#FFFFFF>
				
			<p class=title>Contemplate</p>
			<p class=body><a href=index.html>Utilities menu</a> &gt; Flattener</p><br>
	
	";
	

# require a current version of the extractor before proceeding

	$required_version = 1.0;
	$extractor_text = get_file("assembler.cgi", "filesystem", 0);
	if ($extractor_text =~ /version (\d+\.\d+)/) {
		$installed_version = $1;
		if ($installed_version < $required_version) {
			print "Error: This version of the Flattener requires version $required_version or newer of Contemplate (assembler.cgi).<p>";
			$stop = 1;
		}
	}
	

# present some options on the first run
	
	if ((!$flatten)&&(!$input_file)&&(!$unflatten)&&(!$stop)) {
	
	##
	# show the intro page
	##
	
		print "
			
			<p class=subheading>Flatten all dynamic pages</p>
			<p class=body>Before you do this, create a folder called \"flattened\" at the root level of your website, and give it world-write access (chmod a+w flattened)</p>
			
			<form name=flatten method=post>
			
				<p class=body><input type=submit value=Flatten></p><br>
				
				<input type=hidden name=flatten value=1>
				
			</form>
			
			<p class=subheading>Parse individual files</p>
			<p class=body>Use this option to convert a file that contains links to dynamic pages, even if the file itself isn't dynamically generated<br>
			Enter paths relative to the site root</p>
			
			<form name=parse method=post>
			
				<table><tr valign=bottom><td>
				
					<p class=body>Input file<br>
					<input type=text name=input_file></p>
				
				</td><td>
				
					<p class=body>Output file<br>
					<input type=text name=output_file></p>
				
				</td></tr></table>
				
				<p class=body><input type=submit value=Parse></p><br>
			
			</form>
		
			<p class=subheading>Unflatten a flattened site</p>
			<p class=body>Use this option to update the dynamic files from which a flattened site was generated if the flattened files have been edited<br>
			Before you do this, give world-write access to all content files (chmod -R a+w content)</p>
			
			<form name=unflatten method=post>
			
				<p class=body><input type=submit value=Unflatten><input type=hidden name=unflatten value=1></p><br>
			
			</form>
			
			<div class=body>
			
		";
		

	} else {
	
	
	# grab the text of the pages.txt file; both options will use it
	
		$pages_file = get_file($read_page_definitions_from, "filesystem", 0);
		
	
		if ($flatten) {
		
		##
		# flatten the site
		##
		
			# parse the pages file to get an array of page names and an array of URLs
			
				@pages = (); @URLs = ();
				@page_names = get_page_names($pages_file);
				for ($i=0; $i<@page_names; $i++) {
					$this_page_name = @page_names[$i];
					$this_page = "../flattened/$this_page_name.html";
					$this_URL = "../contemplate/assembler.cgi?page=$this_page_name&skip_rendering=1";
					@pages[$i] = $this_page;
					@URLs[$i] = $this_URL;
				}
			
			# open each URL, change its dynamic links to static ones, and save it to its page name
			
				for ($i=0; $i<@pages; $i++) {
				
					# get the dynamic page
					$file_missing = 0;
					$page_rendered = get_file(@URLs[$i], "http", 0);
					
					if ($file_missing) {
						$result .= "<font color=red>$page_rendered</font><br>"; # that will contain the error if $file_missing == 1
						$failures++;
					} else {

						# convert all the dynamic URLs to flattened ones
						$page_rendered = convert_URLs($page_rendered, @pages[$i]);
					
						# save the flattened page
						open (myfile, ">".absolute_path($pages[$i], "filesystem")) or
						$result .= "<font color=red>Error: Can't open the file @pages[$i] for flattening.</font><br>";
						if ($result =~ /Can't open/) {
							$failures++;
						} else {
							print myfile $page_rendered;
							$result .= "Processing @pages[$i]<br>";
							$successes++;
							close (myfile);
						}
						
						# provide feedback as the script runs
						print $result;
						$result = "";
					
					}
				
				}
		
			# show success rate and, if errors, offer tips
		
				print "<br><b>Created $successes files and encountered $failures errors</b><p>";
		
	
		} elsif ($input_file) {
	
		##
		# parse a single file
		##
		
			# open the file, change its dynamic links to static ones, and save it to its output location
			
				# in case the paths aren't relative to the contemplate folder
				$input_file = ($input_file =~ /\.\.\//) ? $input_file : "../".$input_file ;
				$output_file = ($output_file =~ /\.\.\//) ? $output_file : "../".$output_file ;
				
				# get the file
				$delimiter = ($input_file !~ /\?/) ? "?" : "&" ;
				$file = get_file($input_file.$delimiter."skip_rendering=1", "http", 0);
				
				# convert all the dynamic URLs to flattened ones
				$file = convert_URLs($file, $input_file);
			
				# save the parsed file
				open (myfile, ">".absolute_path($output_file, "filesystem")) or
				$failures++;
				if (!$failures) {
					print myfile $file;
					close (myfile);
				}
				
			# show result
		
				if (!$failures) {
					print "<b>Converted $input_file successfully</b><p>";
				} else {
					print "Error: Couldn't open the file $output_file for saving.<br>";
					print "<b>Failed to convert $input_file</b><p>";
				}
				
		
		} elsif ($unflatten) {
	
		##
		# move changes to the flattened files back into the dynamic files
		##
		
			# get a list of flat pages

				@flat_files = get_directory_listing("../flattened/");
			
			# open assembler.cgi?page=$page&get_info=1 for each flat page, but skip if there's a flattener error
			
				#@flat_files = ("field_1.html"); # for testing one file at a time
				
				$dynamic_files = ();
				for ($i=0; $i<@flat_files; $i++) {
				
					@flat_files[$i] = "../flattened/".@flat_files[$i];
					
					$extension = (@flat_files[$i] =~ /\.php/) ? "php" : "cgi" ;
					@dynamic_files[$i] = "../contemplate/assembler.".$extension."?page=".@flat_files[$i];
					@dynamic_files[$i] =~ s/page=\.\.\/flattened\//page=/;
					@dynamic_files[$i] =~ s/\.\w+$//;
									
					$flat_file = get_file(@flat_files[$i], "filesystem", 0);
					$dynamic_file = get_file(@dynamic_files[$i]."&get_info=1&skip_rendering=1", "http", 0);
				
					if ($dynamic_file =~ /Flattener error/) {
						print "<font color=red>Error: Couldn't find dynamic page for $flat_files[$i]</font><br>";
						$failures++;
					} else {
						print "<br>Processing file @dynamic_files[$i]<br>";
						
						# something about the last character of each file prevented a match to the last template piece, so strip them off now
						$dynamic_file =~ s/(.*).(<\/template_piece-.*)/$1$2/;
						$flat_file = substr($flat_file, 0, -1);
						
						# convert flattened URLs in the flat file back to their dynamic counterparts for comparison
						$flat_file = unconvert_URLs($flat_file, $dynamic_file); # select one or the other URL option based on what's in the dynamic file
						if ($unconvert_error) {
							print "<font color=red>$unconvert_error</font>";
							$failures++;
						} else {
						
							# loop through the file info and collect all the template pieces
							$j = 1; @template_pieces = ();
							while ($dynamic_file =~ /<template_piece-$j>(.*)<\/template_piece-$j>/) {
								@template_pieces[($j-1)] = $1;
								$j++;
							}
							
							# loop through template pieces and parse flat and dynamic files to make two arrays of content pieces
							$flat_file_copy = $flat_file;
							$flat_pieces = ();
							$dynamic_pieces = ();
							for ($j=0; $j<(@template_pieces-1); $j++) {

								$changed = 0;
								$j_plus = $j+1; $j_plus_plus = $j+2;
								$next_piece = "flattener-no-match-flag";
								$temp = substr($flat_file_copy, 0, length(@template_pieces[$j]));
								if ($temp eq @template_pieces[$j]) {

									# strip the first template piece right off
									$flat_file_copy = substr($flat_file_copy, length(@template_pieces[$j]));
									
									# then scan for a match for the second template piece
									$range = length($flat_file_copy) - length(@template_pieces[$j_plus]);
									for ($k=0; $k<=$range; $k++) {
										if (substr($flat_file_copy, $k, length(@template_pieces[$j_plus])) eq @template_pieces[$j_plus]) {
											$next_piece = substr($flat_file_copy, 0, $k);
											$flat_file_copy = substr($flat_file_copy, $k, length($flat_file_copy));
											$k = $range + 1;
										}
									}
									if ($next_piece eq "flattener-no-match-flag") {
										$changed = 2;
									}
								} else {
									$changed = 1;
								}
								if ($changed) {
								# all the preceding lines except $j_plus = $j+1 could be avoided with this line, but it doesn't quite work -- too greedy?
								#if ($flat_file_copy !~ /\Q@template_pieces[$j]\E(.*)(\Q@template_pieces[$j_plus]\E.*)/) {
									print "<font color=red>Error: Template piece ".($j+$changed)." has been changed in @flat_files[$i]</font><br>";
									print "Hint: If using conditional tags, check to see that all conditions are the same as when flattened<br>";
									#print "\r\r<template_piece $j_plus>@template_pieces[$j]</template_piece $j_plus>";
									#print "\r\r<template_piece $j_plus_plus>@template_pieces[$j_plus]</template_piece $j_plus_plus>";
									#print "\r\r<@flat_files[$i]>$flat_file_copy</@flat_files[$i]>";
									$failures++;
									$j = @template_pieces; # stop processing this file
								} else {
								
									@flat_pieces[$j] = $next_piece; # $1
									
									if ($dynamic_file =~ /<content-$j_plus>(.*)<\/content-$j_plus>/) {
										@dynamic_pieces[$j] = $1;
									}

									# if content from flat file and dynamic file are different, open the content file and replace dynamic with flat
									if (@flat_pieces[$j] eq @dynamic_pieces[$j]) {
										print "Piece $j_plus is the same<br>";
									} else {
											
										# don't bother with certain embed types
										if ($dynamic_file =~ /<embed_type-$j_plus>random<\/embed_type-$j_plus>/) {
											print "Skipping random content in piece $j_plus<br>";
										} elsif ($dynamic_file =~ /<embed_type-$j_plus>env_.+<\/embed_type-$j_plus>/) {
											print "Skipping environment variable in piece $j_plus<br>";
										} elsif ($dynamic_file =~ /<embed_type-$j_plus>passthr.+<\/embed_type-$j_plus>/) {
											print "Skipping passthru content in piece $j_plus<br>";
										} else {

											print "<font color=green>Updating piece $j_plus</font><br>";
											
											# open, update, and save
											$this_file = ""; $this_failure = 0;
											if ($dynamic_file =~ /<content_file-$j_plus>(.*)<\/content_file-$j_plus>/) {
												$this_file = $1;
												$content = get_file($this_file, "filesystem", 0);
												
												$content =~ s/\Q@dynamic_pieces[$j]\E/@flat_pieces[$j]/g;

												open (myfile, ">".absolute_path($this_file, "filesystem")) or
												$this_failure++;
												if (!$this_failure) {
													print myfile $content;
													if ($changed_files !~ /$this_file/) { $changed_files .= $this_file.","; }
													close (myfile);
												}
											} else {
												$this_failure++;
											}

											if ($this_failure) {
												if (!$this_file) { $this_file = "(unknown)"; }
												print "<font color=red>Error: Couldn't save changes to content file $this_file</font><br>";
												$failures++;
											} else {
												$changes++;
											}
											
											#print "<flat piece>@flat_pieces[$j]</flat piece><p>\r\r"; # debug
											#print "<dynamic piece>@dynamic_pieces[$j]</dynamic piece><p>\r\r"; # debug
											#print "<flat file>$flat_file</flat file><p>\r\r"; # debug
											#print "<dynamic file>$dynamic_file</dynamic file><p>\r\r"; # debug
										
										}
										
									}
								
								}
								
							}
									
						}
					
					}
				
				}
				
			# show result
		
				if (length($changed_files) > 0) {
					$changed_files = substr($changed_files, 0, -1);
					@changed_files = split(",", $changed_files);
					$changed_files_count = @changed_files;
				} else {
					$changed_files_count = 0;
				}
				print "<br><b>Updated $changes fields in $changed_files_count files with $failures errors</b><p>";
		
		}
	
		print "</div>";

		if (!$stop) {
			print "<p class=body><a href=JavaScript:history.back()>Back</a></p>";
		}
				
		print $output; # we don't use the $output variable in this script, but this helps us share code with assembler.cgi


# finish off a big conditional up there

	}
	
	
# we're done!

	print "</body></html>";

	exit;
